//sceneTex (sampler2D): the final scene image.
//center (vec2): mouse position (in texture coord space: [0 ; 1]).
//time (float): shockwave elapsed time in second.
//shockParams (vec3): shockwave parameters

uniform sampler2D sceneTex; // 0
uniform vec2 center; // Mouse position
uniform float elapsedTime; // effect elapsed elapsedTime
uniform vec3 shockParams; // 10.0, 0.8, 0.1




void main()
{
    // convert it to seconds
//    float elapsedTime = uElapsedTime/1000.f;

    vec2 uv = gl_TexCoord[0].xy;
    vec2 texCoord = uv;

    float distance = distance(uv, center);

    if ( (distance <= (elapsedTime + shockParams.z)) &&
       (distance >= (elapsedTime - shockParams.z)) )
    {
        float diff = (distance - elapsedTime);
        float powDiff = 1.0 - pow(abs(diff*shockParams.x),shockParams.y);

        float diffTime = diff  * powDiff;
        vec2 diffUV = normalize(uv - center);
        texCoord = uv + (diffUV * diffTime);
    }
    gl_FragColor = texture2D(sceneTex, texCoord);
}
