/**
* \file entity_bullet.cpp
* Fichier dans dossier "engine"


mEnemy.Init(CRunner::GetInstance()->GetBatteryModel(mModelIterator->first),0);


*/
#include "IStaticBattery.hpp"
#include <fusion/logging/Logger.hpp>
#include "../config.hpp"
#include "../game_engine.hpp"
#include "CMissile.hpp"
#include "CBullet.hpp"
#include "../fleets/IFleet.hpp"
#include <cmath>


//onPeacefulDeath()
//
//onCombatDeath()
using namespace irr;


// TO allow override of "tostring" lua operator
//TODO je pourrai mm ajouter un const
std::ostream&
operator<<(std::ostream& os, const IStaticBattery& battery)
{
//&battery <<
    os << &battery;
    return os;
}



/// Constructor   _lvlMgr(0),IFleet* fleet
//IFleet* , const irr::core::vector3df& pos, const irr::core::vector3df& forwardVec
IStaticBattery::IStaticBattery() :
_node(0)
, _fleet(0)
//_next(0),
//_previous(0),
, _offscreenCounter(0)
, _damageInflictedOnCollision(0)
, _range(0)
, _bonus(0)
, _life(-1)
, _rotationSpeed(conf::DEFAULT_ROTATION_SPEED)
, _target(0)
//_withinScreen(true)
{

//    FUS_ASSERT( _node );



}




//destructor
IStaticBattery::~IStaticBattery()
{

    // Remove from a list
    //removeFromList();
}


void
//IStaticBattery::
getVectorFromAngle(const float& angle, irr::core::vector3df& vectorToRotate)
{
    //angle = normalizeAngle(angle);
    vectorToRotate.rotateXZBy ( angle );
}









void
IStaticBattery::setMesh(irr::scene::IAnimatedMesh* mesh)
{
    FUS_ASSERT( _node != 0 && "Node should exist");

    _node->setMesh( mesh );
}


//void IStaticBattery::setMesh(const char* meshFilename){
////        FUS_ASSERT( getFleet() != 0 );
//    setMesh( getFleet()->getMesh(meshFilename));
//}


void
IStaticBattery::setup(
//            const char* model,
            irr::scene::IAnimatedMesh* mesh
            , const float& range,
            const int& life,
            const int& damage,
            const int& bonus
        )
{

    //setMesh(model);

    _range = range;
    _life = life;
    _damageInflictedOnCollision = damage;
    _bonus = bonus;

    _node->setMesh( mesh );

    // HACK
//    irr::scene::ISceneManager* smgr = CGameEngine::getInstance()->scene();

//    setWithinScreen(false);
    _offscreenCounter = 0;

}




int
IStaticBattery::stillOutOfScreen(const bool& outOfScreen)
{
    //!
    if( outOfScreen){
        ++_offscreenCounter;
    }
    else {
        _offscreenCounter = 0;
    }
    return _offscreenCounter;
}

//
void
IStaticBattery::updateRotation()
{
    FUS_ASSERT( _target != nullptr );

    //const float maxDelta = 5.f;
    TVector3df rotationDelta = computeAnglesToFacePosition( this->_target->getPosition() );

    //_LOG_WARNING << rotationDelta;
//maxDelta
    rotationDelta.Y = irr::core::clamp(rotationDelta.Y, - _rotationSpeed , _rotationSpeed );
    //rotationDelta.Y = 5;
  //      _INFO << "rotation delta after clamp : " << rotationDelta.Y;
    TVector3df newRotation = rotationDelta + getRotation() ;
    //newRotation.Y = fmodf(newRotation.Y,360.f);
    setRotation( newRotation );

    //_INFO << "rotation" << getRotation().Y;
        //rotationToDirection (const vector3d< T > &forwards=vector3d< T >(0, 0, 1)) const
    //_forward = getRotation().rotationToDirection ();

}

void
IStaticBattery::onGettingCached()
{

//    _node->setVisible(false);
}


// TODO renommer en facePosition
TVector3df
//float
//IStaticBattery::computeAnglesToFacePosition(IStaticBattery* target) const
IStaticBattery::computeAnglesToFacePosition(const TVector3df& targetPos) const
{

    //FUS_ASSERT(target);

//    // If no target returns
//    if(target == 0) {
//        return 0;
//    }


//rotation.Y = fmodf(rotation.Y,360.f);
    //else compute new rotation
    const TVector3df toTarget( targetPos - this->getPosition() );

    //Get the rotations that would make a (0,0,1) direction vector point
    //in the same direction as this direction vector.
    TVector3df horizontalAngle = toTarget.getHorizontalAngle();

    // HACK TO suppress once model finished
    horizontalAngle.X = 0;

    //getRotation().Y = fmodf(getRotation().Y, 360.f);

    //_INFO << "toTarget angle" << horizontalAngle.Y << "/ship getRotation" <<this->getRotation();
    // clamp values

//
//TVector3df temp =
    //fmodf(this->getRotation().Y,360)
    // en fait y a juste le Y qui nous intéresse ?
    TVector3df rotationDelta = horizontalAngle - this->getRotation() ;

   // _INFO << "Y delta " << rotationDelta;
    if(rotationDelta.Y > 180.f)
    {

        rotationDelta.Y -= 360.f;
    }
    else if(rotationDelta.Y < -180.f)
    {
        rotationDelta.Y += 360.f;
    }
    return ( rotationDelta );
//        _INFO << "rotation delta: " << rotationDelta.Y ;

}


//bool
//IStaticBattery::operator==(const IStaticBattery& other) const {
//    _LOG_WARNING << "OPERATOR CALLED";
//    return true;
//}



// TODO remove/test ?
void
IStaticBattery::exportPositionToLua(lua_State* L) const
{

    const TVector3df& pos = getPosition();
    lua_pushnumber(L, pos.X);
    lua_pushnumber(L, pos.Y);
    lua_pushnumber(L, pos.Z);
}



//std::string
//IStaticBattery::concat(std::string& str1,std::string& str2) const {
//    return "Battery test";
//}


// cf forum d'irrlicht fabsf ??
float normalizeAngle(const float& angle)
{
    float newAngle = angle;
    while (newAngle < 0)
    {
        newAngle += 360.f;
    }

    while (newAngle > 360)
    {
        newAngle -= 360.f;
    }
    return newAngle;
}





void
IStaticBattery::setRotation( const TVector3df& rotation )
{

    TVector3df temp = rotation;
    //_INFO << "Avant fmodf" << temp.Y;
    //temp.Y = fmodf(rotation.Y,360.f);
    temp.Y =  normalizeAngle(rotation.Y);
    //_INFO << "Apres fmodf" << temp.Y;

    _node->setRotation( temp );
}




TVector3df
IStaticBattery::predictPositionIn(const TTimeUnit& futureDelay) const
{

    return getPosition() + computeLastFrameSpeedVector() * futureDelay;
}




/// Update position
/// return true quand il doit etre tue
bool
IStaticBattery::update(const TTimer::TimeType& elapsedTime)
{

    //! TODO appeler la fleet ?
//    if( ! _withinScreen)
//    {
//        // TODO alors on lance un timer !
////        _timer += elapsedTime;
//        ++_offscreenCounter;
//    }
//
//
//
// // TODO mettre ca ailleurss dans une autre fonction
//    // check if it's still within screen
//    const TVector3df& pos = getPosition();


    return false;
}




//void
//IStaticBattery::onCollision(IStaticBattery* battery)
//{
////battery->getRange()
//    /// TODO HACK Plus le range est grand plus il inflige de degats
//    addDamage( 3 );
//}
//
//

//
//bool
//IStaticBattery::checkCollision(IStaticBattery* battery)
//{
//
//    float distance = battery->getPosition().getDistanceFromSQ(this->getPosition() );
//
////    _INFO << "this range:" << this->getRange();
////    _INFO << "battery range:" << battery->getRange();
//
//    return ( distance < _FUSION_POW2(this->getRange() + battery->getRange()) );
//}



void
IStaticBattery::addTrackingBattery(IStaticBattery* missile)
{
    //
    _INFO << "Adding Battery [" << this << "] tracked by [" << missile << "]";
    _trackingMissiles.push_back(missile);
}





void
IStaticBattery::removeTrackingBattery(IStaticBattery* missile)
{
    //
    _INFO << "Missile [" << missile << "] removed";
    _trackingMissiles.remove(missile);
}




void
IStaticBattery::kill()
{

    //
    //unlink();

    // inform tracking missiles that this battery doesn't exist anymore
    if(_trackingMissiles.size() )
    {

//        TMissileList::iterator i(_trackingMissiles.begin()),end(_trackingMissiles.begin());
        auto i(_trackingMissiles.begin()),end(_trackingMissiles.begin());
        for(;i != end;++i)
        {
            (*i)->setTarget(0);
            //_targetedBy->setTarget(0);
        }

    }

    // remove itself from tracking batteries
    if(_target)
    {
        _target->removeTrackingBattery(this);
    }

    // met a jour le reste
    _node->setVisible(false);
}






void
IStaticBattery::setTarget(IStaticBattery* battery)
{

    _INFO << "Missile tracking battery [" << battery << "]";
// mettre un animator followsplien
    if(battery)
    {

        // If already tracking an entity
        if(_target)
        {
            _LOG_WARNING << "Already has a target [" << _target << "]";
            // Tells this entity it is not tracked anymore by this missile
            _target->removeTrackingBattery(this);
        }

        _target = battery;
        //_vitesse.set(50,0,-50);
        battery->addTrackingBattery(this);
    }
    else
    {
        _LOG_WARNING << "Target battery == null";
    }
}





void
IStaticBattery::translate(const float& x,const float& y ,const float& z)
{

    /*BOOST_ASSERT(_node);

    // A mettre en mode DEBUG seulement
    if(!_node){
        _LOG_ERROR << "No node registered for this object";
        //_previousPos = getPosition();
    }
    else {
        */
    _previousPos = getPosition();
    _node->setPosition( _previousPos + TVector3df(x,y,z) );
    //}
}


//
//bool
//IStaticBattery::outOfScreenTimeout() const
//{
//    return false;
//}



void
IStaticBattery::setFleet( IFleet* fleet )
{
    FUS_ASSERT( fleet != 0 && "Should belong to a fleet");
    _fleet = fleet;
    //_node->setParent( fleet->_fleetRootNode );
}







void
IStaticBattery::setPosition(const TVector3df& newPos)
{

    //_node->.set(x,y,z);
    FUS_ASSERT(_node != nullptr && "Node not created");

    // A mettre en mode DEBUG seulement
//    if(!_node)
//    {
//        _LOG_ERROR << "No node registered for this object";
//        //_previousPos = getPosition();
//    }
//    else
//    {
        _previousPos = getPosition();
        _node->setPosition( newPos );
//    }
}




void
IStaticBattery::addDamage(const int& damage)
{

    _life -= damage;

//    if( _life < 0)
//    {
//        _fleet->killBattery( this );
//    }
};


//TODO supprimer et remplacer par setup ?
//void
//IStaticBattery::reset(){
//
//
//    _damageInflictedOnCollision = 0;
//    //_timer.setTimer( conf::_BC_BULLET_LIFETIME_MS );
//
//    if(_node){
//        //_node->drop(); // TODO do a remove avant
//        //_node->remove();
//        //_node = 0;
//    }
//
//}


void
IStaticBattery::onTimeoutDisparition()
{

    _node->setVisible(false);
}



void
IStaticBattery::onDeath()
{
    //_fleet->killEntity(this);
    _node->setVisible(false);
}




