#ifndef IWalkyrieMode_Hpp
#define IWalkyrieMode_Hpp

#include <irrlicht.h>
#include <array>
#include <memory>
//#include <irrlicht.h>

class SBindCache;
class IPlayerAnimator;

enum ESpeed {

Lateral = 0,
Forward,
DefaultForward,
Backward,
Roll,
Yaw,
SpeedsCount // Should remain last
};



class IWalkyrieMode
{

public:


    const char* Name;

    // std::pair<position,rotation> ? move ? apres on doit le clamper ?
    // Lui passer un const IWalkyrie ?
    //std::unique_ptr<
    IPlayerAnimator* DefaultAnimator;


    void setDefaultAnimator(IPlayerAnimator* animator)
    {
//        DefaultAnimator.reset( animator );
        DefaultAnimator = animator ;
    }

    IPlayerAnimator* getDefaultAnimator() const
    {
//        DefaultAnimator.reset( animator );
        return DefaultAnimator ;
    }

    IWalkyrieMode* getNextMode() const
    {
        return _nextMode;
    }

    IWalkyrieMode* getPreviousMode() const
    {
        return _previousMode;
    }


    void setAvailableModes(IWalkyrieMode* previous,IWalkyrieMode* next)
    {
        _previousMode = previous;
        _nextMode = next;
    }

    // TODO rename
    //TVector3df
    irr::core::vector3df _cameraRecul;

protected:
    //friend class CPlayer;
    IWalkyrieMode* _nextMode;
    IWalkyrieMode* _previousMode;


    typedef std::array<float,SpeedsCount> TSpeedList;
    TSpeedList Speed;     // laterale,devant,derriere,rotation speed




    float YAngle;  //angles de tir,lock
    float ZAngle;  //angles de tir,lock
    //irr::core::vector3df AngleLimits;
    //float LockAngle;
    float Range;        // ptet la hitbox de l'appareil ?
    int Frame;
    irr::f32 AnimationSpeed;

    // TODO deplacer dans IPlayerMode
//    typedef void (CPlayer::*TProcessMoveFunction)(void);

public:
//    TProcessMoveFunction processMoveFunction;

    IWalkyrieMode(const char* name );

    //IWalkyrieMode* operator=(const IWalkyrieMode* mode);

    IWalkyrieMode*
    setupSpeeds(const float& lateralSpeed,
                const float& forwardSpeed,const float& defaultForward,
                const float& backwardSpeed,const float& rollingSpeed,
                const float& yawSpeed);

    IWalkyrieMode*
    setAngleBounds(const float& rollingLimit,const float& yawLimit);

    IWalkyrieMode*
    setRange(const float& range);


    const float& getRange() const {
        return Range;
    };

    void interpolate(const IWalkyrieMode* start,const IWalkyrieMode* objective,const float& progress);

    /**
    *
    */
    IWalkyrieMode*
    setCameraRecul(const float x,const float& y,const float& z){
        _cameraRecul.set(0,y,z);
        return this;
    }



    //const float getCruiseSpeed() const { return };

    IWalkyrieMode*
    defineAnimation(const int& noFrame,const irr::f32& animationSpeed);

//    IWalkyrieMode
//    inline getInterpolated(const float& progress,const IWalkyrieMode* objective) const {
//
//        IWalkyrieMode mode = *this;
//        mode.interpolate(progress,objective);
//        return mode;
//    }


//    static IWalkyrieMode interpolate(const float& progress,const IWalkyrieMode* start,const IWalkyrieMode* objective);

    // TODO a deplacer



    const float& getYawLimit() const {
        return YAngle;
    }

    const float& getSpeed(const ESpeed& speedId) const {
        return this->Speed[speedId];
    }

    // A deplacer ?
    inline int getFrame() const { return Frame;};

    void getAngleLimits(float& yAngle,float& zAngle) const {

        yAngle = this->YAngle;
        zAngle = this->ZAngle;
    };


    const irr::core::vector3df& getCameraRecul() const {
        return _cameraRecul;
    }

    void printMode() const;

    //virtual void
};


#endif
