#include "CBindCollectionPlayer.hpp"
//#include "IInputCache.hpp"

//#define FULL_ID(id,no) std::make_pair(id,no)
#define DESCRIPTOR(it) (it)->second


CBindCollectionPlayer::CBindCollectionPlayer() :
    LastUpdatedTime(0)
{
    //! Cstror
}



void
CBindCollectionPlayer::updateCache( TTimeUnit const& currentTime, TCache& cache) const
{

    //BOOST_ASSERT(cache);

    if(currentTime <= LastUpdateTime)
        return false;

//    for( TDescriptorList::right_const_iterator i( _descriptors.right.begin()), end( _descriptors.right.end() ); i!= end; ++i){
    bool state = false;

    // getAssociatedIds
    for( TDescriptorList::iterator i( _descriptors.begin()), end( _descriptors.end() ); i!= end; ++i)
    {

        const TFullId& fullId = i->first;
        const CBindDescriptor& descriptor = DESCRIPTOR(i);

        //!
        SBindCache& cache = cache[fullId];

        //! if could retrieve state of descriptor
        if( ::getState(descriptor,state) )
        {
            cache.update(currentTime, descriptor, state );
        }

        // if descriptors match
//        if(eventDescriptor == descriptor){
//
//            // Update cache
//            cache.update( currentTime,descriptor,currentState);
//        }
    }


    LastUpdatedTime = currentTime;
    return true;
}

/*
void
//CBindCollectionPlayer::updateCache( TTimeUnit const& currentTime, CInputManager& inputMgr, TCache * cache) const
// TODO idealement je pourrais supprimer ca
CBindCollectionPlayer::updateCache( TTimeUnit const& currentTime, const CBindDescriptor& eventDescriptor,const bool& currentState)
{

    //BOOST_ASSERT(cache);

//    for( TDescriptorList::right_const_iterator i( _descriptors.right.begin()), end( _descriptors.right.end() ); i!= end; ++i){


    // getAssociatedIds
    for( TDescriptorList::iterator i( _descriptors.begin()), end( _descriptors.end() ); i!= end; ++i)
    {

        const TFullId& fullId = i->first;
        const CBindDescriptor& descriptor = i->second.Descriptor;
        SBindCache& cache = i->second.State;

        // if descriptors match
        if(eventDescriptor == descriptor){

            // Update cache
            cache.update( currentTime,descriptor,currentState);
        }
    }


}
*/




CBindDescriptor&
CBindCollectionPlayer::setBind(TFullId const& fullId,CBindDescriptor const& descriptor)
{

    //auto fullId = FULL_ID(id,param);

    //std::pair< TDescriptorList::left_iterator, bool> result = _descriptors.left.insert( TDescriptorList::left_value_type(fullId,descriptor ) );
    std::pair< TDescriptorList::iterator, bool> result = _descriptors.insert( std::make_pair(fullId, descriptor ) );

    // if matching id already exist
//    if( result.second == false){
//
//        // overwrite current descriptor
//        result.first->second.Descriptor = descriptor;
//    }

//    result.first->second.Descriptor = descriptor;
//    return result.first->second.Descriptor;
    CBindDescriptor& temp = result.first->second;
    temp = descriptor;
    return temp;
}


std::vector< CBindCollectionPlayer::TFullId >
CBindCollectionPlayer::getAssociatedIds( const CBindDescriptor & descriptor, std::size_t const& limit) const
{


    std::vector<TFullId>  ids;

    //for( TDescriptorList::right_const_iterator i( _descriptors.right.begin()), end( _descriptors.right.end() ); i!= end; ++i){
    for( TDescriptorList::const_iterator i( _descriptors.begin()), end( _descriptors.end() ); i!= end; ++i){


        if( descriptor == i->second)
        {

            ids.push_back(i->first);
            if( ids.size() >= limit)
            {
                break;
            }
        }
    }

    return ids;
}


//CBindCollectionPlayer::TOptionalFullId
bool
CBindCollectionPlayer::containBind(CBindDescriptor const& descriptor,TFullId& id)
{

    //TOptionalFullId ret;
    std::vector<TFullId>  ids;
    ids = getAssociatedIds(descriptor,1);

    if( !ids.empty() )
    {
        id = ids.front();
        return true;
    }

    return false;
}



void
CBindCollectionPlayer::removeBinds(TFullId const& id)
{

//    TIdDescriptors temp;
//    getDescriptors(id,temp);
//    //std::for_each( temp.begin(), temp.end(), [] { _descr} )
//    for(auto i(temp.begin() ),end(temp.end()) ; i != end ; ++i){
//        _descriptors.erase( *i );
//    }

    // TODO
}



//#undef FULL_ID
#undef DESCRIPTOR
