/**
\file
\author
**/
#ifndef IFleet_HPP
#define IFleet_HPP



//#include "CIntrusiveList.hpp"
#include <forward_list>
//std::forward_list
#include <irrlicht.h>
#include <fusion/maths/macros.hpp>
#include <fusion/logging/ILogger.hpp>
#include <array>
#include "def.hpp"
#include "utils/TClock.hpp"


class CPlayer;
class CMissile;
class CBullet;
class IStaticBattery;
class CStaticBattery;

namespace audio {

class IMusicManager;
class ISoundManager;

}
class IParticleManager;
class IPlayableState;


//typedef std::list<CStaticBattery*> TTrackedBatteries;
//: public CIntrusiveList
class IFleet
{
private:
//    audio::ISoundManager* _soundMgr;
    IPlayableState* _state;

protected:
    typedef  std::forward_list< IStaticBattery*> TBatteryContainer;
    TBatteryContainer _activeBatteries;


    //typedef std::array<CIntrusiveList,EEntityType::Count> TDeadPool;
    typedef std::array< TBatteryContainer, EEntityType::Count> TDeadPool;
    static  TDeadPool _deadPool;



    IStaticBattery* getDeadButAllocatedBattery(const EEntityType::EId& type);
    //removeBattery(CStaticBattery*);




    irr::scene::ISceneNode *_fleetRootNode;

//    audio::ISoundManager* getSoundManager() {return _soundMgr;};


public:
    IFleet( IPlayableState* state );
    virtual ~IFleet();


    /** \brief
     *
     * \return Number of entities in this fleet
     *
     */
//    irr::u32 getSize() const { return _activeBatteries.size(); };



    irr::scene::IAnimatedMesh* getMesh(const char* filename);

    void addConfiguredEntityToAliveBatteries(IStaticBattery* battery);


    irr::scene::ISceneNode * getRootNode() const { return _fleetRootNode;};

    static void clearDeadPool();
    static void destroyAll();
    void killAllAlive();


//    void killBattery( IStaticBattery* );
    void killBattery( TBatteryContainer::iterator& it);


    void draw();


    /**
    * Used from Lua
    * \param
    *
    **/
//    CStaticBattery* addStaticBattery(const char* model);
    CStaticBattery* createAndConfigureStaticBattery();

    //CStaticBattery* createAndSetupBattery(CStaticBattery* battery);
//    CMissile* addMissile(const char* model,
//                        const irr::core::vector3df& position,
//                        CStaticBattery* target,
//                        const irr::core::vector3df& speed
//                        );

    //inline,const TVector3df& position
    //,const TVector3df& position
    CBullet* createAndSetupBullet(const char* model,const float& angleDeg);
    CBullet* createAndSetupBullet(const char* model,const TVector3df& forward );

    //
    CMissile* createAndSetupMissile(const char* model,const TVector3df& forward,const TVector3df& position );




    /// TODO old
    IStaticBattery* getNearestEnemy(const TVector3df& position);

    // TODO passer un forward_list
    IStaticBattery* getNextTarget(const std::list<IStaticBattery*>& list);

    bool checkCollisions(IFleet* fleet);

    void update(const TTimer::TimeType&);


    // onFadingDisparition
    virtual void onTimeoutDisparition( IStaticBattery* ) = 0;

protected:
    virtual void onCollision(IStaticBattery* entity1,IStaticBattery* entity2) = 0;
    //TBulletList::iterator deleteBullet(CBullet&);


};

#endif // CENEMYFLEET_HPP
