/**
* \file single.h
**/
#ifndef CDialogStateLua_HPP
#define CDialogStateLua_HPP

#include "../states/IDialogState.hpp"
#include <irrlicht.h>
#include <memory>
#include <lua.hpp>
//#include "../utils/IClock.hpp"

namespace fus
{
    class CLuaThread;
    class CLuaVM;
}

//class CSpeaker;
//class CSpeech;


namespace NAnswerType {

    enum  EId {
        String,
        Integer,
        Any
    };
}

struct lua_State;

class CDialogStateLua :
    public IDialogState
//class CDialogStatePlain : public IBasicGameState
{
private:
    const std::string PathToLuaFile;

protected:
//    lua_State* MainLuaContext;
    lua_State* Thread;


    NAnswerType::EId AnswerType;

public:


    CDialogStateLua(lua_State* L,const std::string& pathToLuaFile );
    virtual ~CDialogStateLua();



    bool load( CGameEngine* engine,irr::scene::ISceneManager* smgr,irr::video::ITexture* screenshot) ;
//    void unload();


    void onUpdate(const TTimeUnit& elapsedTime);

    void onAnswer(const irr::s32& answerId);

    int getReply();

//    void onResume();
//    void onHold();

//	void Draw();
//	bool OnEvent(const irr::SEvent&);

//    CSpeaker* createActor(const std::string&,const std::string&);
//    static CSpeech* createSpeech(const std::string& );


protected:
};

#endif
