#include "IStateManager.hpp"
#include "IGameState.hpp"
//#include "COptionsState.hpp"
//#include "CTransitionState.hpp"
//#include "CMenuState.hpp"
//#include "CScoreState.hpp"
//#include "CSinglePlayerState.hpp"
#include "../game_engine.hpp"
#include <fusion/logging/ILogger.hpp>
#include <algorithm>
#include "../utils/debug.hpp"

///// Store upon the previous one and init state

IStateManager::IStateManager()
//_numberOfStatesToPop(0)
//_stateRemoved(false)
//,_currentState(0)
{

}

IStateManager::~IStateManager()
{
    //! TODO clear registered states

}

//void
//IStateManager::pushEvent(const EStateEvent&,IBasicGameState*)
//{
//
//}


void
IStateManager::pushEvent(const EStateEvent& eventType,TGameState userData)
{

    //!
    _events.push_back( std::make_pair(eventType,userData) );
}



void
IStateManager::replaceTopMostState(TGameState state)
{
    //!
    popState();
    pushState(state);
}



void
IStateManager::resetStackAndPushState(TGameState state)
{
    //!
//    while( !_states.empty() ){
//        _states.pop();
//    }
    pushEvent( EStateEvent::EmptyStack, 0);
    pushState( state );
}



/// Store upon the previous one and init state
void
IStateManager::pushState(TGameState state)
{

//    IBasicGameState* state = 0;

    FUS_ASSERT( state != nullptr );
    pushEvent( EStateEvent::PushState, state );
}



//IBasicGameState* state
void
IStateManager::popState()
{

//    IBasicGameState* state = 0;

//    BOOST_ASSERT( state != 0 );
    pushEvent( EStateEvent::PopState, 0 );
}

//void
//IStateManager::printStates() const {
//
//    //_INFO << _states;
//
//}
//






// TODO getNumberOfStates
// Traite les evenements
// TODO jarter
//bool
void
IStateManager::synchronize()
{

// TODO gerer les onHold && resume retrieveState

    //ratio between pushed/poppded
    std::size_t savedStackSize = _states.size();
//    int stackMaxDelta = 0;
//    int stackCurrentDelta = 0;
    std::size_t stackMinSize = _states.size();

    //if(isStackEmpty()) return 0;
    // TGameState
    const auto topMostState = getTopMostState();
    const auto previousTopMostState = topMostState;

    // Maintenant faut ajouter les states
    for(TEventStack::iterator it( _events.begin()), end(_events.end() ); it != end; ++it)
    {

        const EStateEvent type = it->first;
        TGameState state = it->second;

        if(type == EStateEvent::PushState)
        {


            _INFO <<  "Trying to push state [" << state->getName() << "]";
            //! check it's loaded

//            SPreloadingState params;
//            auto res = RegisteredStates.insert( std::make_pair(state, params) );

            if( !state->isLoaded() )
            {
                _INFO <<  "State unloaded. Trying to load it...";


                if( !loadState( getTopMostState(), state ) )
                {
                    _LOG_ERROR << "Loading state failed " << state->getName();
                    delete state;
                }
                else
                {
                    _INFO << "State loaded, pushing it onto the stack";
                    _states.push_back( state );
                }

            }

            // TODO fus::assert

            // Generate
//            if( !state->isLoaded() )
//            {
//                _LOG_ERROR << "Could not load state [" << state->getName() << "]";
//                delete state;
//            }
//            else
//            {
//                _INFO << "State loaded, pushing it onto the stack";
//                _states.push_back( state );
//            }



        }
        else if(type == EStateEvent::PopState)
        {
            _INFO <<  "Trying to pop state ";

            //|| (_states.top() != state )
            if (isStackEmpty() )
            {
                _LOG_WARNING << " which is not at the top of stack";
            }
            else
            {

                state = _states.back();

                _INFO << "Popping state [" << state->getName() <<  "]";

                _states.pop_back();
                //--stackCurrentDelta;
                //stackMaxDelta = ( stackCurrentDelta < stackMaxDelta) ? stackCurrentDelta : stackMaxDelta;

                stackMinSize = std::min( stackMinSize, _states.size() );
//                    ( _states.size() < stackMinSize) ? stackCurrentDelta : stackMinSize;

                FUS_ASSERT( state->isLoaded() == true && "State should be loaded before trying to unload it.");

                _INFO << "Unloading State...";
                state->unload();
                _INFO << "State unloaded !";

                if( state->isLoaded() )
                {
                    _LOG_ERROR << "Once unloaded, isLoaded should return false";
                }
//              FUS_ASSERT( state->isLoaded() == false && "Once unloaded, isLoaded should return false");


            }
        }
        else if (type == EStateEvent::EmptyStack)
        {
//            while(! isStackEmpty() )
//            {
//                _states.pop_back();
//            }
            _states.clear();
        }
    }


    //! faire une passe

    //
    if(isStackEmpty())
    {
        onStackEmptied();
    }
    // if top most state changed

    //! S'il y a eu des changements
    else if( !_events.empty() )
    {
        //! We Just popped evyrthing on top of stack (might have been pushes too, but were popped straightaway
        if(stackMinSize == _states.size() )
        {
            //
            getTopMostState()->onResume();
        }
        // states got pushed
        else
        {

            //! -1 because we don't want to call onHold on top state
//            auto it = _states.begin();
//            std::advance(it,stackMinSize);
            for(std::size_t i(stackMinSize); i < _states.size()-1; ++i)
            {
                _states[i]->onHold();
            }


        }


        // TODO: can we afford same state
        onNewTopMostState( getTopMostState() );

    }
    //! if no change
    else
    {
        // Do nothing
    }


    _events.clear();
}








/// \function CleanUp()
void
IStateManager::CleanUp()
{

    /// Loop ends when states stack empty
    //while(PopState()) {  }

    //_currentState.reset();

    _INFO << "Clean-up of the engine achieved";

}



