/**
* \file state.h
**/

#ifndef _ISTATEMANAGER_HPP_INCLUDED
#define _ISTATEMANAGER_HPP_INCLUDED

//template<typename ENGINE>//,typename EventReceiver> class IGameState<>


#include <boost/shared_ptr.hpp>
#include <stack>
#include <map>
#include "IGameState.hpp"
#include "../def.hpp"
#include "../utils/debug.hpp"
#include <boost/ptr_container/ptr_vector.hpp>
#include <boost/ptr_container/ptr_list.hpp>
#include <boost/ptr_container/ptr_deque.hpp>
//#include "IGameState.hpp"

//class IGameState;
//class IBasicGameState;


namespace irr {
namespace scene {
class ISceneManager;
}

namespace gui {
class IGUIElement;
}
}


/**
State before loading
**/
struct SPreloadingState
{
//    SPreloadingState(const irr::core::list< IGUIElement * >& elements);

    /**
    Quand on compare la liste d'élements il ne devrait y avoir qu'un seul
    **/
//const irr::core::list< IGUIElement * > Elements;
// TODO savedElements();
//TTempAssociation
std::map<irr::gui::IGUIElement *, irr::gui::IGUIElement * > Elements;
// TODO faire parel pour la scene()
std::map<irr::scene::ISceneNode*, irr::scene::ISceneNode * > Nodes;
bool JustPushed;
};


class IStateManager
{
public:
    typedef IGameState* TGameState;

protected:



    //IBasicGameStatePtr boost::shared_ptr<
    //typedef std::map<IBasicGameStateId, IBasicGameState* > TStatesMap;
    typedef std::vector< TGameState > TStatesStack;
    TStatesStack _states;
    //TStatesMap _stateCollection;


    //! GameState + Loaded or not core::list<>
    // const core::list< IGUIElement * >
    typedef std::map< TGameState, SPreloadingState > TRegisteredStates;
    TRegisteredStates RegisteredStates;

//typedef std::pair< EStateEvent, IBasicGameState*> IBasicGameStateEvent;
    typedef std::vector< std::pair< EStateEvent, TGameState> > TEventStack;
    TEventStack _events;

    //IBasicGameStatePtr _currentState;
//    bool pushState(IBasicGameStateId id);
    //addToAllocatedStates(IBasicGameState);


    void pushEvent(const EStateEvent&, TGameState);

    bool isStackEmpty() const { return _states.empty(); };


    /** \brief Some kind of hack
     *
     * \param previousState
     * \param nextState
     * \return
     *
     */
//    virtual irr::scene::ISceneManager* getMatchingSceneManager(const bool&) = 0;
    virtual bool loadState(TGameState , TGameState) = 0;

public:

    IStateManager();
    virtual ~IStateManager();

    TGameState getTopMostState()
    {
//        BOOST_ASSERT(!isStackEmpty());
        if( isStackEmpty() )
        {
            return 0;
        }

        return _states.back() ;
    };

//    void pushEvent(const NStateEvent::EId&,const IBasicGameStateId&);


    /**
     * \brief
     * \note Should never be called from constructor.
    **/
    void pushState(TGameState state);


    /** \brief replaces the menu at the top of the screens stack
      * (i.e. pops the topmost screen and adds this one instead, but
      * without displaying the second-topmost menu of the stack
      * in-between)
      */
    void replaceTopMostState(TGameState state);

    /**
      * \brief removes the menu at the top of the screens stack
      * If the stack becomes empty after performing the pop (i.e. if it
      * contained only one item prior to the call), the game is aborted.
      * In other cases, the second-topmost screen is displayed.
      * IBasicGameState* state
      */
    void popState();

    /**
      * \brief clears the menu stack and starts afresh with a new stack
      *  containing only the given screen
      */
    void resetStackAndPushState(TGameState state);

//    void resetStackAndPushEvent();
//    /** Will delete allocated states **/
//    void hardResetStackAndPushEvent();



    /**
      * \brief Called when stack reaches 0
      */
    virtual void onStackEmptied() = 0;


    /**
      * \brief Called when top of stack changes
      * \param New top most state
      */
    virtual void onNewTopMostState( TGameState ) = 0;



    /*inline bool ChangeState(IGameState* state,const std::string& desc){
        IBasicGameStatePtr ptr(state);
        return ChangeState(state,desc);
    }*/


    // TODO ppouvoir le remettre ici
    //virtual bool InitState(IBasicGameStatePtr state) = 0;
    /**
     * \brief
     * \return True if any event happened
     **/
    void synchronize();

    virtual void CleanUp() = 0;




};

#endif
